import java.util.Arrays;
import java.util.Iterator;

import org.odmg.DBag;
import org.odmg.Database;
import org.odmg.ODMGException;
import org.odmg.OQLQuery;
import org.odmg.Transaction;

import rasj.RasImplementation;
import rasj.RasMArrayInteger;

public class ReadData {
	private static String server = "localhost";
	private static String port = "7001";
	private static String base = "RASBASE";
	private static String user = "rasguest";
	private static String password = "rasguest";

	public static void main(String[] args) {
		
		Database database = null;
		Transaction transaction = null;
		try {
			RasImplementation app = new RasImplementation("http://" + server + ":" + port);
			app.setUserIdentification(user, password);

			database = app.newDatabase();
			database.open(base, Database.OPEN_READ_ONLY);

			transaction = app.newTransaction();
			transaction.begin();

			OQLQuery selectQuery = app.newOQLQuery();

			// If csv(...) is used, the data-type is changed to RasMArrayByte.
			// If the ushort-values are read as byte, wrong values are returned.
			// Casting to integer or short causes an exception.
			selectQuery.create(
					"select marray x in [1:10, 0:23] values (c[2016, 12, x[0], x[1], 50, 450, 450]) from MemTestData as c");
			DBag resultSet = (DBag) selectQuery.execute();

			Iterator<?> iter = resultSet.iterator();

			RasMArrayInteger result = (RasMArrayInteger) iter.next();
			int[] readData = result.getIntArray();

			System.out.println(Arrays.toString(readData));

			// Only read access was required.
			transaction.abort();
		} catch (ODMGException e) {
			e.printStackTrace();
			if (transaction != null) {
				transaction.abort();
			}
		} finally {
			if (database != null) {
				try {
					database.close();
				} catch (ODMGException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
